searchNodes=[{"doc":"Internal representation of an admission review.","ref":"BonnyPlug.AdmissionReview.html","title":"BonnyPlug.AdmissionReview","type":"module"},{"doc":"","ref":"BonnyPlug.AdmissionReview.html#create/1","title":"BonnyPlug.AdmissionReview.create/1","type":"function"},{"doc":"","ref":"BonnyPlug.AdmissionReview.html#t:t/0","title":"BonnyPlug.AdmissionReview.t/0","type":"type"},{"doc":"Helper functions for admission review request handling. This module is imported when using WebhookHandler.","ref":"BonnyPlug.AdmissionReview.Request.html","title":"BonnyPlug.AdmissionReview.Request","type":"module"},{"doc":"Adds a warning to the admission review's response.Examplesiex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.add_warning(admission_review, &quot;warning&quot;) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;warnings&quot; =&gt; [&quot;warning&quot;]}} iex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;warnings&quot; =&gt; [&quot;existing_warning&quot;]}} ...&gt; BonnyPlug.AdmissionReview.Request.add_warning(admission_review, &quot;new_warning&quot;) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;warnings&quot; =&gt; [&quot;new_warning&quot;, &quot;existing_warning&quot;]}}","ref":"BonnyPlug.AdmissionReview.Request.html#add_warning/2","title":"BonnyPlug.AdmissionReview.Request.add_warning/2","type":"function"},{"doc":"Responds by allowing the operationExamplesiex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.allow(admission_review) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;allowed&quot; =&gt; true}}","ref":"BonnyPlug.AdmissionReview.Request.html#allow/1","title":"BonnyPlug.AdmissionReview.Request.allow/1","type":"function"},{"doc":"Verifies that a given field has not been mutated.Examplesiex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{&quot;object&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}, &quot;oldObject&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.check_immutable(admission_review, [&quot;spec&quot;, &quot;immutable&quot;]) %BonnyPlug.AdmissionReview{request: %{&quot;object&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}, &quot;oldObject&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}}, response: %{}} iex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{&quot;object&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;new_value&quot;}}, &quot;oldObject&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.check_immutable(admission_review, [&quot;spec&quot;, &quot;immutable&quot;]) %BonnyPlug.AdmissionReview{request: %{&quot;object&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;new_value&quot;}}, &quot;oldObject&quot; =&gt; %{&quot;spec&quot; =&gt; %{&quot;immutable&quot; =&gt; &quot;value&quot;}}}, response: %{&quot;allowed&quot; =&gt; false, &quot;status&quot; =&gt; %{&quot;code&quot; =&gt; 400, &quot;message&quot; =&gt; &quot;The field .spec.immutable is immutable.&quot;}}}","ref":"BonnyPlug.AdmissionReview.Request.html#check_immutable/2","title":"BonnyPlug.AdmissionReview.Request.check_immutable/2","type":"function"},{"doc":"Responds by denying the operationExamplesiex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.deny(admission_review) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;allowed&quot; =&gt; false}}","ref":"BonnyPlug.AdmissionReview.Request.html#deny/1","title":"BonnyPlug.AdmissionReview.Request.deny/1","type":"function"},{"doc":"Responds by denying the operation, returning response code and messageExamplesiex&gt; admission_review = %BonnyPlug.AdmissionReview{request: %{}, response: %{}} ...&gt; BonnyPlug.AdmissionReview.Request.deny(admission_review, 403, &quot;foo&quot;) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;allowed&quot; =&gt; false, &quot;status&quot; =&gt; %{&quot;code&quot; =&gt; 403, &quot;message&quot; =&gt; &quot;foo&quot;}}} iex&gt; BonnyPlug.AdmissionReview.Request.deny(%BonnyPlug.AdmissionReview{request: %{}, response: %{}}, &quot;foo&quot;) %BonnyPlug.AdmissionReview{request: %{}, response: %{&quot;allowed&quot; =&gt; false, &quot;status&quot; =&gt; %{&quot;code&quot; =&gt; 400, &quot;message&quot; =&gt; &quot;foo&quot;}}}","ref":"BonnyPlug.AdmissionReview.Request.html#deny/3","title":"BonnyPlug.AdmissionReview.Request.deny/3","type":"function"},{"doc":"This module dispatches the admission webhook requests to the handlers. You can use this module in your webhook handler to connect it to the Plug.OptionsWhen use-ing this module, you have to tell it about the resource you want to act upon:Custom Resource Definitioncrd - If you have a CRD YAML file, just pass the path to the file as option crd. The WebhookHandler will extract the required values from the file.Explicit Resource SpecificationThe WebhookHandler needs to know the following values from the resource you want to act upon:group - The group of the resource, e.g. &quot;apps&quot;plural - The plural name of the resource, e.g. &quot;deployments&quot;api_versions - A list of versions of the resource, e.g. [&quot;v1beta1&quot;, &quot;v1&quot;]Functions to be implemented in your Webhook HandlerYour webhook handler should implement at least one of the two functions validating_webhook/1 and mutating_webhook/1. These are going to be called by this module depending on whether the incoming request is of type :validating_webhook or :mutating_webhook according to the BonnyPlug.WebhookPlug configuration.Examplesdefmodule FooAdmissionWebhookHandler do use BonnyPlug.WebhookHandler, crd: &quot;manifest/src/crds/foo.crd.yaml&quot; @impl true def validating_webhook(admission_review) do check_immutable(admission_review, [&quot;spec&quot;, &quot;someField&quot;]) end @impl true def mutating_webhook(admission_review) do allow(admission_review) end enddefmodule BarAdmissionWebhookHandler do use BonnyPlug.WebhookHandler, group: &quot;my.operator.com&quot;, resource: &quot;barresources&quot;, api_versions: [&quot;v1&quot;] @impl true def validating_webhook(admission_review) do check_immutable(admission_review, [&quot;spec&quot;, &quot;someField&quot;]) end @impl true def mutating_webhook(admission_review) do deny(admission_review) end end","ref":"BonnyPlug.WebhookHandler.html","title":"BonnyPlug.WebhookHandler","type":"behaviour"},{"doc":"","ref":"BonnyPlug.WebhookHandler.html#c:mutating_webhook/1","title":"BonnyPlug.WebhookHandler.mutating_webhook/1","type":"callback"},{"doc":"","ref":"BonnyPlug.WebhookHandler.html#c:process/2","title":"BonnyPlug.WebhookHandler.process/2","type":"callback"},{"doc":"","ref":"BonnyPlug.WebhookHandler.html#c:validating_webhook/1","title":"BonnyPlug.WebhookHandler.validating_webhook/1","type":"callback"},{"doc":"","ref":"BonnyPlug.WebhookHandler.html#t:webhook_type/0","title":"BonnyPlug.WebhookHandler.webhook_type/0","type":"type"},{"doc":"Plug that processes incoming admission webhook requests. Valid requests are forwarded to given webhook handlers.You have to specify the :webhook_type you want to forward to this plug. The :webhook_type has to be be either :validating_webhook or :mutating_webhook.ExamplesCompile time configurationIn a Phoenix router you would forward post requests to this plug:post &quot;/admission-review/validate&quot;, BonnyPlug.WebhookPlug, webhook_type: :validating_webhook, handlers: [MyApp.WebhookHandlers.FooResourceWebhookHandler] post &quot;/admission-review/mutate&quot;, BonnyPlug.WebhookPlug, webhook_type: :mutating_webhook, handlers: [MyApp.WebhookHandlers.BarResourceWebhookHandler]Runtime configurationIn the example above, the handlers are defined at compile time. If you need to define the handlers at runtime, you can define them in config/runtime.exs. Note that in this case, handlers are global for all instances of the plug, unless declared at compile time like above.Your config/runtime.exs:import Config config :bonny_plug, BonnyPlug.WebhookPlug handlers: [MyApp.WebhookHandlers.FooResourceWebhookHandler]Your router.ex:post &quot;/admission-review/validate&quot;, BonnyPlug.WebhookPlug, webhook_type: :validating_webhook # handlers set at compile time according to config post &quot;/admission-review/mutate&quot;, BonnyPlug.WebhookPlug, webhook_type: :mutating_webhook, handlers: [MyApp.WebhookHandlers.BarResourceWebhookHandler] # NOT overwritten at compile time!","ref":"BonnyPlug.WebhookPlug.html","title":"BonnyPlug.WebhookPlug","type":"module"},{"doc":"","ref":"BonnyPlug.WebhookPlug.html#call/2","title":"BonnyPlug.WebhookPlug.call/2","type":"function"},{"doc":"","ref":"BonnyPlug.WebhookPlug.html#init/1","title":"BonnyPlug.WebhookPlug.init/1","type":"function"},{"doc":"","ref":"BonnyPlug.WebhookPlug.html#process/3","title":"BonnyPlug.WebhookPlug.process/3","type":"function"},{"doc":"","ref":"BonnyPlug.WebhookPlug.html#t:webhook_type/0","title":"BonnyPlug.WebhookPlug.webhook_type/0","type":"type"},{"doc":"bonny_plug - Kubernetes Admission Webooks Plug bonny_plug aims to extend the Kubernetes development framework Bonny with admission hooks. However, the library can be used on its own and has no dependencies to Bonny.","ref":"readme.html","title":"bonny_plug - Kubernetes Admission Webooks Plug","type":"extras"},{"doc":"def deps do [ {:bonny_plug, &quot;~&gt; 1.0&quot;} ] end","ref":"readme.html#installation","title":"bonny_plug - Kubernetes Admission Webooks Plug - Installation","type":"extras"},{"doc":"PlugAdd the plug to a Phoenix or Plug router to forward admission webhook requests to the handlers. You have to pass the webhook_type and the list of handlers to the plug. See below for ways to implement webhook handlers.post &quot;/admission-review/validate&quot;, BonnyPlug.WebhookPlug, webhook_type: :validating_webhook, handlers: [MyApp.WebhookHandlers.FooResourceWebhookHandler] post &quot;/admission-review/mutate&quot;, BonnyPlug.WebhookPlug, webhook_type: :mutating_webhook, handlers: [MyApp.WebhookHandlers.FooResourceWebhookHandler]Webhook HandlersYou're gonna want to write code that validates/mutates incoming admission webhook requests. You do this by writing webhook handlers and passing them via the handlers options to the WebhookPlug as described above. There are more and less explicit ways to implement a webhook handler.Using BonnyPlug.WebhookHandler with CRDsThe simplest way if you are working with Custom Resource Definitions is to use BonnyPlug.WebhookHandler in your webhook handler and tell it where to find your CRD YAML file. BonnyPlug.WebhookHandler will then extract all necessary information from the YAML file and forward matching calls to your request handlers.Your webhook handler now has to implement at least one of the two possible request handler functions validating_webhook/1 and mutating_webhook/1. Both take a struct %BonnyPlug.AdmissionReview{} as argument, operate on it and return it.use BonnyPlug.WebhookHandler imports BonnyPlug.AdmissionReview.Request so you have helper functions like allow/1, deny/1, check_immutable/2, etc. available in your request handlers.defmodule FooAdmissionWebhookHandler do use BonnyPlug.WebhookHandler, crd: &quot;manifest/src/crds/foo.crd.yaml&quot; @impl true def validating_webhook(admission_review) do check_immutable(admission_review, [&quot;spec&quot;, &quot;someField&quot;]) end @impl true def mutating_webhook(admission_review) do allow(admission_review) end endUsing BonnyPlug.WebhookHandler with other ResourcesIf for some reason you want to add webhooks to other resources, you can use BonnyPlug.WebhookHandler and pass it the necessary information about the resource. These are its group, the supported api_versions and its plural resource name.defmodule BarAdmissionWebhookHandler do use BonnyPlug.WebhookHandler, group: &quot;my.operator.com&quot;, api_versions: [&quot;v1&quot;], resource: &quot;barresources&quot; @impl true def validating_webhook(admission_review) do check_immutable(admission_review, [&quot;spec&quot;, &quot;someField&quot;]) end @impl true def mutating_webhook(admission_review) do deny(admission_review) end endExplicit Implementation of a Webhook HandlerIf you don't like the magic of use and macros, feel free to implement the full handler yourself. It should implement the behaviour @behaviour BonnyPlug.WebhookHandler and therefore the function process/2. Note that process/2 is called for every request so you have check whether your handler has to handle it or not.defmodule ExplicitAdmissionWebhookHandler do @behaviour BonnyPlug.WebhookHandler alias BonnyPlug.AdmissionReview alias BonnyPlug.AdmissionReview.Request @impl true def process(%AdmissionReview{request: %{&quot;...&quot; =&gt; &quot;&quot;}} = admission_review, :validating_webhook) do Request.check_immutable(admission_review, [&quot;spec&quot;, &quot;someField&quot;]) end def process(ignored_request), do: ignored_request end","ref":"readme.html#usage","title":"bonny_plug - Kubernetes Admission Webooks Plug - Usage","type":"extras"}]